package org.jeecg.modules.stm.rectify.approve.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.rectify.approve.entity.StRectifyApprove;
import org.jeecg.modules.stm.rectify.approve.service.IStRectifyApproveService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;


import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 整改审核
 * @Author: jeecg-boot
 * @Date:   2023-07-21
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/rectify.approve/stRectifyApprove")
@Slf4j
public class StRectifyApproveController extends JeecgController<StRectifyApprove, IStRectifyApproveService> {
	@Autowired
	private IStRectifyApproveService stRectifyApproveService;
	
	/**
	 * 分页列表查询
	 *
	 * @param stRectifyApprove
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "整改审核-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<StRectifyApprove>> queryPageList(StRectifyApprove stRectifyApprove,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<StRectifyApprove> queryWrapper = QueryGenerator.initQueryWrapper(stRectifyApprove, req.getParameterMap());
		Page<StRectifyApprove> page = new Page<StRectifyApprove>(pageNo, pageSize);
		IPage<StRectifyApprove> pageList = stRectifyApproveService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param stRectifyApprove
	 * @return
	 */
	@AutoLog(value = "整改审核-添加")
	  
	@RequiresPermissions("rectify.approve:st_rectify_approve:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody StRectifyApprove stRectifyApprove) {
		stRectifyApproveService.save(stRectifyApprove);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param stRectifyApprove
	 * @return
	 */
	@AutoLog(value = "整改审核-编辑")
	  
	@RequiresPermissions("rectify.approve:st_rectify_approve:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody StRectifyApprove stRectifyApprove) {
		stRectifyApproveService.updateById(stRectifyApprove);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "整改审核-通过id删除")
	  
	@RequiresPermissions("rectify.approve:st_rectify_approve:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		stRectifyApproveService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "整改审核-批量删除")
	  
	@RequiresPermissions("rectify.approve:st_rectify_approve:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.stRectifyApproveService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "整改审核-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<StRectifyApprove> queryById(@RequestParam(name="id",required=true) String id) {
		StRectifyApprove stRectifyApprove = stRectifyApproveService.getById(id);
		if(stRectifyApprove==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(stRectifyApprove);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param stRectifyApprove
    */
    @RequiresPermissions("rectify.approve:st_rectify_approve:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, StRectifyApprove stRectifyApprove) {
        return super.exportXls(request, stRectifyApprove, StRectifyApprove.class, "整改审核");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("rectify.approve:st_rectify_approve:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, StRectifyApprove.class);
    }

}
